#include <stdint.h>


//#define  ACCUM_SIZE  16   // Passed in as -D gcc parameter. (Min=8+WORD_POSITION, Max=64) Bit width of generated random numbers.
//#define  PARITY_BIT  0    // Bit number of summed result to substitute with summing parity calculation.
//#define  CONSTANT_A  11   // Passed in as -D gcc parameter.
//#define  CONSTANT_B  2   // Passed in as -D gcc parameter.
//#define  CONSTANT_C  6   // Passed in as -D gcc parameter.
//#define  CONSTANT_D  7   // Passed in as -D gcc parameter.

//#define  ACCUM_MASK  (((1ULL<<(ACCUM_SIZE-1))-1)<<1|1)  // Bit of a shuffle to work on all 64 bits :)
//typedef  uint64_t  rngword_t  // Defined in parent source


// Seed the state array.  Seed MUST not be all zero.
static rngword_t  s[2] = {1, 0};

static inline rngword_t  rotl( rngword_t value, int shift )  {
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	return (value << shift) | (value >> (ACCUM_SIZE - shift));
#else
	return ((value << shift) | ((value & ACCUM_MASK) >> (ACCUM_SIZE - shift))) & ACCUM_MASK;
#endif
}


static rngword_t  next( void )
{
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	rngword_t  s0 = s[0];
	rngword_t  s1 = s[1];
#else
	rngword_t  s0 = s[0] & ACCUM_MASK;
	rngword_t  s1 = s[1] & ACCUM_MASK;
#endif
//	int  shift = s1 >> (ACCUM_SIZE-3);
//	rngword_t  result = (rotl( s0, shift ) + rotl( s1, shift )) & ACCUM_MASK;
//	rngword_t  result = (rotl( s0 + s1, ACCUM_SIZE/2 ) + s0) & ACCUM_MASK;
//	rngword_t  result = (s0 + s1) & ACCUM_MASK;
	rngword_t  result = s0 + s1;  // Keep the extended carry for parity calc
#ifdef PARITY_BIT
	rngword_t  parity = 0;
	int  shift;


//Calc parity of first summing
//	for( shift=1; shift <= ACCUM_SIZE; shift++ )  { // Parity of bits [16:1]
	for( shift=0; shift <= ACCUM_SIZE; shift++ )  { // Parity of bits [16:0]
		parity = parity ^ (result >> shift);
	}
//	result = result ^ (parity & 1);  // and parity with bit0
//	result = ((result & ACCUM_MASK) >> 1) | (parity << (ACCUM_SIZE-1));
	result = result & (ACCUM_MASK^(1ULL<<PARITY_BIT)) | ((parity & 1) << PARITY_BIT);
#endif

#if CONSTANT_D > 0
//New addition from authors:  Rotation and second summing
	result = rotl( result, CONSTANT_D ) + s0;

//*
#ifdef PARITY_BIT
//Calc parity of second summing
	parity = 0;
//	for( shift=1; shift <= ACCUM_SIZE; shift++ )  { // Parity of bits [16:1]
	for( shift=0; shift <= ACCUM_SIZE; shift++ )  { // Parity of bits [16:0]
		parity = parity ^ (result >> shift);
	}
//	result = result ^ (parity & 1);  // and parity with bit0
//	result = result | (parity & 1) << ACCUM_SIZE;
//	result = ((result & ACCUM_MASK) >> 1) | (parity << (ACCUM_SIZE-1));
	result = result & (ACCUM_MASK^(1ULL<<PARITY_BIT)) | ((parity & 1) << PARITY_BIT);
#endif
//*/
#endif

//Perform the iteration
//	s1 ^= s0;
//	s0 = rotl(s0, CONSTANT_A) ^ s1 ^ (s1 << CONSTANT_B) & ACCUM_MASK;
//	s1 = rotl(s1, CONSTANT_C);
//Second iteration to check how alternate sampling will score
	s1 ^= s0;
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	s[0] = rotl(s0, CONSTANT_A) ^ s1 ^ (s1 << CONSTANT_B);
#else
	s[0] = rotl(s0, CONSTANT_A) ^ s1 ^ (s1 << CONSTANT_B) & ACCUM_MASK;
#endif
	s[1] = rotl(s1, CONSTANT_C);

//	result = (rotl( s[0] + s[1], CONSTANT_D ) + s[0]) & ACCUM_MASK;
#if (ACCUM_SIZE == 16) || (ACCUM_SIZE == 32) || (ACCUM_SIZE == 64)
	return( result );
#else
	return( result & ACCUM_MASK );
#endif
}
